(function() {

    unLoadChapterList = true;
    //加载正文、更新章节标示

    var FrontPageAPI = {
        loadChapter: function(json) {
            if (json.status == 200) {
                preChapter = json.preChapter;
                nextChapter = json.nextChapter;
                content = json.novelContent;
                height = json.height || 0;
                novelLink = json.novelLink || "";
                if (json.extra_data) {
                    extra_data = json.extra_data;
                };
                content = content.replace(/&nbsp;/g, "");
                content = '<p>' + content.replace(/\n/g, '</p><p>') + '</p>';
                content = content.replace(/\s+/g, "");
                $('#title').html(json.title);
                $('#content').html(content);
                if (novelLink) {
                    $('#link').html(novelLink);
                } else {
                    $('#link_wrap').hide(); 
                }
                // window.scroll(0, height);
                //加载目录
                if (unLoadChapterList) {
                    setTimeout("NovelTransInvoker.loadChapterList('FrontPageAPI.loadChapterList')", 500);
                }
                FrontPageAPI.intialSetting();

            } else {
                toast(json.status, 2000);
            }
        },
        //加载下一章
        loadNextChapter: function() {
            NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
        },
        //加载前一章
        loadPreChapter: function() {
            NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
        },

        //加载目录
        loadChapterList: function(json) {
            if (json.status == 200) {
                var tempList = json.chapterList;
                chapterList = [];
                $('#totalNumber').html("本书共" + json.totalChapterNumber + "章");
                totalChapterNumber = json.totalChapterNumber;
                for (var i = 0; i < tempList.length; i++) {
                    chapterList.push('<li ckey="' + tempList[i].ckey + '" index = "' + tempList[i].index + '"><a href="javascript:void(0)">' + tempList[i].name + '</a></li>');
                };
                $('#catalog-title').show();
                $('#loading').hide();
                $('#chapterList').append(chapterList.join(''));
                unLoadChapterList = false;
                myScroll.refresh();
            } else {
                toast(json.status, 2000);
            }
        },

        //设置、上下章节等控制条的展现与隐藏切换。若控制条存在，调用该方法隐藏控制条；若控制条隐藏，调用该方法展现控制条。
        controlBarToggle: function() {
            if ($('#subnav').css('display') != 'none') {
                controlBarHide();
            } else {
                controlBarShow();
            }
        },

        // App获取控制条展现状态
        getControlBarStatus: function() {
            return $('#subnav').css('display') != 'none' ? 'show' : 'hide';
        },
        loadSetting:function(conf){
             var json;
            if (conf) {
                json = JSON.parse(conf);
                haveIntialSetting = true;
            } else {
                return;
            };
            userConf.bgColor = json.bgColor || 0;
            userConf.fontSize = json.fontSize || 20;
            userConf.lineHeight = json.lineHeight || 1.6;
            userConf.flipType = json.flipType || "horizontal";
            userConf.nightMode = json.nightMode || "off";
            userConf.haveShowIntro = json.haveShowIntro || false;

        },
        //背景颜色、字体初始化
        intialSetting: function() {

            if (userConf.flipType != 'vertical') {

                if (haveIntialHorizontalFlip) {
                    FlipUtils.setPage(flipActivity);
                    return;
                }else{
                     FlipUtils.setFlipType(userConf.flipType);
                     $('#horizontal').addClass('cur');
                    $('#vertical').removeClass('cur');
                     haveIntialHorizontalFlip = true;
                }
                if(userConf.haveShowIntro==false){
                    $('#introduction').show();
                    userConf.haveShowIntro=true;
                    resetUserConf();
                }
            }else {
                $('#horizontal').removeClass('cur');
                $('#vertical').addClass('cur');
            }

            if (userConf.fontSize) {
                $('#main').css('font-size', parseInt(userConf.fontSize));
            }

            if(userConf.lineHeight){
                $('#main p').css('line-height',userConf.lineHeight);
            }
            if (userConf.nightMode == 'on') {
                $('body').attr('class', 'bg-night');
                $('#nightMode').removeClass('night');
                $('#nightMode').html($('#nightMode').html().replace('夜间', '白天'));

            } else {
                $('body').attr('class', themes[userConf.bgColor]);
                $('#theme>div>a').removeClass('themebox-cur');
                // $('#theme>div').removeClass('selected');
                $('#theme>div').eq(userConf.bgColor).children().addClass('themebox-cur');
                // $('#theme>div').eq(userConf.bgColor).addClass('selected');
            }

            window.scroll(0,0);
        },
        showCommentNum:function(json){
            if(json){
                var reg = /\d+/;
                var countNumber = parseInt(json.count.match(reg)[0]);
                if(countNumber>0){
                    $('#commentNumber').text(json.count);
                    $('#commentNumber').show();
                }else{
                    $('#commentNumber').hide();
                }
                $('#comment').attr('author',json.author);
                $('#comment').attr('bookName',json.name);
                $('#comment').removeClass('none');
            }
        },

        //app获取滚动条滚动的高度
        getScrollTop: function() {
            return parseInt(document.body.scrollTop);
        },

        //设置滚动条滚动高度
        setScrollTop: function(height) {
            window.scroll(0, height);
        },
        //app获取extra字段
        getExtraData: function() {
            NovelTransInvoker.onReceiveExtraData(extra_data);
        },
        uploadLastConf:function(){}

    };

    window.FrontPageAPI = FrontPageAPI;

    //冒泡提示
    window.toast = function(tip, intVal) {
        intVal = intVal || 2500;
        if ($('#abs-toast').length == 0) {
            $('body').prepend('<div id="abs-toast" style="display: none;width:206px;text-align: center;border-radius: 2px;background-color: rgba(0, 0, 0, 0.48);position: fixed;top: 220px;left: 50%;line-height: 28px;margin: 0 0 0 -103px;color: #fff;padding: 5px;z-index: 999;"></div>');
        }
        var $toast = $('#abs-toast');
        if ($toast.css('display') != 'none')
            return;
        $toast.html(tip);
        $toast.show();
        setTimeout(function() {
            $toast.hide();
        }, intVal);
    };

})(window)

window.FlipUtils = {
    setFlipType: function(type) {
        $("#main").unbind("click");
        var $main = $('#main');
        var oBox = document.querySelector('.read_page');
        var oCon = oBox.querySelector('.read_page_con');
        if (!$main.hasClass("read_page")) {
            $main.addClass("read_page");
        }
        x = 0;
        n = 0;
        _offset = 0;
        columnWidth = 0;
        pages = 0;
        title = "";
        document.body.style.overflow='hidden';
        document.body.style.position='fixed';
        FlipUtils.setPage();
        FlipUtils.fnTouch();
        haveIntialHorizontalFlip = true;
    },

    setPage: function(trigger) {
        setTimeout(function() {
            var oBox = document.querySelector('.read_page');
            var oCon = oBox.querySelector('.read_page_con');
            //title content
            var title = $('#title').html(),
                con = $('#content').html();
            $("#title").html(title);
            $('#content').html(con);
            $('.loading-btns').hide();
            columnWidth = oCon.clientWidth + 16;
            oBox.style.WebkitColumnWidth = columnWidth + 'px';
            clientHeight = document.documentElement.clientHeight;
            oBox.style.height = clientHeight + 'px';

            oBox.style.WebkitTransition = 'none';
            pages = Math.ceil(oCon.offsetHeight / (document.documentElement.clientHeight - _offset));
            if (pages == 0) {
                pages = 1;
            }
            if (trigger == 'horizontalPre') {
                n = pages - 1;
            }
            if (trigger == 'horizontalNext' || trigger == 'btnFlip') {
                n = 0;
            }

            /*            n=Math.ceil(oCon.offsetHeight/(document.documentElement.clientHeight-_offset))*n/pages;// 当前总页数*转屏前的第n页/转屏前的总页数
            n=Math.floor(n);// 当前页，向下取整*/

            x = -n * columnWidth;
            oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
            flipActivity = "";

        }, 200);
    },

    fnTouch: function() {
        var $main = document.getElementById('main');
        var oBox = document.querySelector('.read_page');
        var oCon = oBox.querySelector('.read_page_con');
        $main.addEventListener('touchstart', function(ev) {

            oBox.style.WebkitTransition = 'none';
            var disX = ev.targetTouches[0].pageX - x;
            var startX = ev.targetTouches[0].pageX;
            var startY = ev.targetTouches[0].pageY;

            function fnEnd(ev) {
                var endX, endY;
                endX = ev.changedTouches[0].pageX;
                endY = ev.changedTouches[0].pageY;
                // $main.removeEventListener('touchmove',fnMove,false);
                $main.removeEventListener('touchend', fnEnd, false);
                columnWidth = oCon.clientWidth + 16;
                // 判断是向左滑 还是向右滑
                if (Math.abs(startX - endX) > 10 && startX > endX) {
                    controlBarHide();
                    if ((n + 1) == pages) {

                            flipActivity = "horizontalNext";
                            NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
                        return;
                    };
                    n++;
                    x = -n * columnWidth;
                    oBox.style.WebkitTransition = '.2s all ease';
                    oBox.style.WebkitTransform = 'translateX(' + x + 'px)';

                } else if (Math.abs(startX - endX) > 10 && startX < endX) {
                    controlBarHide();
                    if (n == 0) {

                            flipActivity = "horizontalPre";
                            NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
                        return;
                    };
                    n--;
                    if (n < 0) { n = 0 };
                    x = -n * columnWidth;
                    oBox.style.WebkitTransition = '.2s all ease';
                    oBox.style.WebkitTransform = 'translateX(' + x + 'px)';


                } else {
                    if (startX > columnWidth * 2 / 3 || (startY > clientHeight * 3 / 4 && startX > columnWidth * 1 / 3)) {

                        controlBarHide();
                        if ((n + 1) == pages) {
                                flipActivity = "horizontalNext";
                                NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
                            return;
                        };

                        n++;
                        x = -n * columnWidth;
                        // oBox.style.WebkitTransition='.2s all ease';
                        oBox.style.WebkitTransform = 'translateX(' + x + 'px)';
                    } else if (startX < columnWidth / 3 || (startY < clientHeight * 1 / 4 && startX < columnWidth * 2 / 3)) {
                        controlBarHide();
                        if (n == 0) {
                                flipActivity = "horizontalPre";
                                NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
                            return;
                        };
                        n--;
                        if (n < 0) { n = 0 };
                        x = -n * columnWidth;
                        // oBox.style.WebkitTransition='.2s all ease';
                        oBox.style.WebkitTransform = 'translateX(' + x + 'px)';

                    } else {
                        controlBartoggle();
                    }
                }
            }
            // $main.addEventListener('touchmove',fnMove,false);  
            $main.addEventListener('touchend', fnEnd, false);
            ev.preventDefault();
        }, false);
    }

}


window.APPLogUtil = {

        CountTypeLog:function(key){
            NovelTransInvoker.onCountEvent(key);
        },
        EnumTypeLog:function(key,value){
            NovelTransInvoker.onEnumEvent(key,value);
        },
        CustomTypeLog:function(key,value){
          NovelTransInvoker.onCustomEvent(key,value);
        }

}

function throttle(fn, interval) {
    var last;
    var timer;
    var interval = interval || 200;
    return function() {
        var th = this;
        var args = arguments;
        var now = +new Date();
        if (last && now - last < interval) {
            clearTimeout(timer);
            timer = setTimeout(function() {
                last = now;
                fn.apply(th, args);
            }, interval);
        } else {
            last = now;
            fn.apply(th, args);
        }
    }
}



function swipe(ev){
                var endX;
                var style = adConf.style;
                var startX = ev.targetTouches[0].pageX;
                $('body').on('touchend',tounchEnd);

                function tounchEnd(ev){
                    endX = ev.changedTouches[0].pageX;
                    $('body').unbind('touchend'); 

                // 判断是向左滑 还是向右滑
                    if (Math.abs(startX - endX) > 10 && startX > endX) { 
                        if(AdPosition == 'chapterStart'){
                            hideAd();
                        }else if(AdPosition == 'chapterEnd'){
                            flipActivity = "horizontalNext";
                            NovelTransInvoker.loadNextChapter(nextChapter, 'FrontPageAPI.loadChapter');
                            hideAd();
                        }

                    } else if (Math.abs(startX - endX) > 10 && startX < endX) {
                        // NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
                        if(AdPosition == 'chapterStart'){
                            flipActivity = "horizontalPre";
                            NovelTransInvoker.loadPreviousChapter(preChapter, 'FrontPageAPI.loadChapter');
                            hideAd();
                        }else if(AdPosition == 'chapterEnd'){
                            hideAd();
                        }
                    } 
                        
               }


            function hideAd(){
                $('.wrapper').show();
                $('.ad-col'+style).hide();
                $('.hand-btn').hide();
                $('body').unbind('touchstart');
            }


                      
}



